*****************
FUNCTION DOWINDOW
*****************

* Function to create a window with shadow 
* Please see DOWINDOW.DOC for documentation and usage
* Author : William Bautista
* Created: 09/04/91
* Version: 1.0
* Notes  : Use at your own risk - this is a shareware utility
*          for dBase IV version 1.1. Please direct all of your
*          comments and any suggestions to the author.
* Voice #: (818) 500-6550

PARAMETERS WINNAME
ON ERROR DO PROCERR
OLDTALK = SET("TALK")
SET TALK OFF
CLEAR
DO STORESET
SET STAT OFF
SET SCOR OFF
SET ESCA OFF
SET CURS OFF
FRROW    = 00
FRCOL    = 00
TOROW    = 02
TOCOL    = 02
FRROW1   = 01
FRCOL1   = 01
TOROW1   = 03
TOCOL1   = 03
OLFRRW   = FRROW
OLFRCL   = FRCOL
OLTORW   = TOROW
OLTOCL   = TOCOL
OLFRRW1  = FRROW1
OLFRCL1  = FRCOL1
OLTORW1  = TOROW1
OLTOCL1  = TOCOL1
KEYPRESS = 00
BORDERTYPE = ""
MESSAGE    = ""
DO WINHELP
IF LEN(WINNAME) # 0
	WINDONME = CHR(34) + WINNAME + ".WIN" + CHR(34)
	IF LEN(WINNAME) > 05
		WINDOSDW = "SDW" + SUBSTR(WINNAME,1,5)
	ELSE
		WINDOSDW = "SDW" + WINNAME
	ENDIF
	IF FILE(&WINDONME)
		MESSAGE = "Window " + WINNAME + " exist"
		??MSG(MESSAGE)
		RESTORE WINDOW &WINNAME, &WINDOSDW  FROM &WINNAME
		ACTIVATE WINDOW &WINDOSDW
		ACTIVATE WINDOW &WINNAME
		REDEFINE = .F.
		IF REPLY2(REDEFINE,"Redefine window?")
			DEACTIVATE WINDOW &WINNAME, &WINDOSDW
			RELEASE WINDOW &WINNAME
			DO DOWIN
		ELSE
			DEACTIVATE WINDOW &WINNAME, &WINDOSDW
			RELEASE WINDOW &WINNAME
		ENDIF
	ELSE
		DO DOWIN
	ENDIF
ELSE
	MESSAGE = "Unable to create window"
ENDIF
??MSG(MESSAGE)
ON ERROR
ON ESCAPE
ON KEY
DO RESETSET
SET TALK ON
RETURN("")
* EOP: -- DOWINDOW

***************
PROCEDURE DOWIN
***************
DO DEFPOP WITH BORDERTYPE
DO WHILE KEYPRESS # 27
	DO SIZEWIN
	IF KEYPRESS = 28
		DO WINHELP
	ELSE
		DO DEFWIN
	ENDIF
	KEYPRESS = INKEY(0)
ENDDO
SAVEIT = .F.
IF REPLY2(SAVEIT,"Save window settings?")
	OLDSAFE = SET("SAFE")
	SET SAFE OFF
	SAVE WINDOWS &WINNAME, &WINDOSDW TO &WINNAME
	SET SAFE &OLDSAFE
	MESSAGE = "Window created and save under name of " + WINNAME + ".WIN"
ELSE
	MESSAGE = "Window not created"
ENDIF
DEACTIVATE WINDOW &WINNAME, &WINDOSDW
RELEASE WINDOW &WINNAME, &WINDOSDW
RETURN
* EOP: -- DOWIN

****************
PROCEDURE DEFPOP
****************

PARAMETERS BORDERTYPE
DEFINE   POPUP  &WINNAME FROM 00,00
DEFINE   BAR 01 OF &WINNAME PROMPT " Select Border Style " SKIP
DEFINE   BAR 02 OF &WINNAME PROMPT "" SKIP
DEFINE   BAR 03 OF &WINNAME PROMPT "       SINGLE        "
DEFINE   BAR 04 OF &WINNAME PROMPT "       DOUBLE        "
DEFINE   BAR 05 OF &WINNAME PROMPT "       PANEL         "
DEFINE   BAR 06 OF &WINNAME PROMPT "       NONE          "
ON SELECTION POPUP &WINNAME DEACTIVATE POPUP
ACTIVATE POPUP &WINNAME
IF BAR() = 03 .OR. BAR() = 00
	BORDERTYPE = ""
ELSE
	BORDERTYPE = LTRIM(TRIM(PROMPT()))
ENDIF
RELEASE POPUP &WINNAME
RETURN
* EOP: -- DEFPOP

****************
PROCEDURE DEFWIN
****************

DEFINE   WINDOW &WINDOSDW FROM FRROW1,FRCOL1 TO TOROW1,TOCOL1 NONE COLOR N+/N,N+/N
ACTIVATE WINDOW &WINDOSDW
DEFINE   WINDOW &WINNAME FROM FRROW,FRCOL TO TOROW,TOCOL &BORDERTYPE
ACTIVATE WINDOW &WINNAME
OLFRRW   = FRROW
OLFRCL   = FRCOL
OLTORW   = TOROW
OLTOCL   = TOCOL
OLFRRW1  = FRROW1
OLFRCL1  = FRCOL1
OLTORW1  = TOROW1
OLTOCL1  = TOCOL1
RETURN
* EOP: -- DEFWIN

*****************
PROCEDURE SIZEWIN
*****************
DO CASE
	CASE KEYPRESS = 31
	* MOVE WINDOW ONE ROW UP
	FRROW  = FRROW  - 1
	FRROW1 = FRROW1 - 1
	IF FRROW < 00
		FRROW  = 00
		FRROW1 = 01
	ENDIF
	CASE KEYPRESS = 30
	* MOVE WINDOW ONE ROW DOWN
	FRROW  = FRROW  + 1
	FRROW1 = FRROW1 + 1
	IF FRROW > 21
		FRROW  = 21
		FRROW1 = 22
	ENDIF
	CASE KEYPRESS = 01
	* MOVE WINDOW ONE COLUMN TO THE LEFT
	FRCOL  = FRCOL  - 1
	FRCOL1 = FRCOL1 - 1
	IF FRCOL < 00
		FRCOL  = 00
		FRCOL1 = 01
	ENDIF
	CASE KEYPRESS = 06
	* MOVE WINDOW ONE COLUMN TO THE RIGHT
	FRCOL  = FRCOL  + 1
	FRCOL1 = FRCOL1 + 1
	IF FRCOL > 76
		FRCOL  = 76
		FRCOL1 = 77
	ENDIF
	CASE KEYPRESS = 04
	* EXPAND  WINDOW ONE COLUMN TO THE RIGHT
	TOCOL  = TOCOL  + 2
	TOCOL1 = TOCOL1 + 2
	IF TOCOL > 78
		TOCOL  = 78
		TOCOL1 = 79
	ENDIF
	CASE KEYPRESS = 19
	* RETRACT WINDOW ONE COLUMN TO THE LEFT
	TOCOL  = TOCOL  - 1
	TOCOL1 = TOCOL1 - 1
	IF TOCOL < FRCOL
		TOCOL  = TOCOL  + 1
		TOCOL1 = TOCOL1 + 1
	ENDIF
	CASE KEYPRESS = 05
	* RETRACT WINDOW ONE ROW UP
	TOROW  = TOROW  - 1
	TOROW1 = TOROW1 - 1
	IF TOROW < FRROW
		TOROW  = TOROW  + 1
		TOROW1 = TOROW1 + 1
	ENDIF
	CASE KEYPRESS = 24
	* EXPAND  WINDOW ONE ROW DOWN
	TOROW  = TOROW  + 1
	TOROW1 = TOROW1 + 1
	IF TOROW > 23
		TOROW  = 23
		TOROW1 = 24
	ENDIF
ENDCASE
RETURN
* EOP: -- SIZEWIN

*****************
PROCEDURE PROCERR
*****************
MESSAGE = MESSAGE()
DO CASE
	CASE ERROR() = 46
	DO CASE
		CASE KEYPRESS = 31
			MESSAGE = "UNABLE TO MOVE WINDOW ONE ROW UP"
		CASE KEYPRESS = 30
			MESSAGE = "UNABLE TO MOVE WINDOW ONE ROW DOWN"
		CASE KEYPRESS = 01
			MESSAGE = "UNABLE TO MOVE WINDOW ONE COLUMN TO THE LEFT"
		CASE KEYPRESS = 06
			MESSAGE = "UNABLE TO MOVE WINDOW ONE COLUMN TO THE RIGHT"
		CASE KEYPRESS = 04
			MESSAGE = "UNABLE TO EXPAND  WINDOW ONE COLUMN TO THE RIGHT"
		CASE KEYPRESS = 19
			MESSAGE = "UNABLE TO RETRACT WINDOW ONE COLUMN TO THE LEFT"
		CASE KEYPRESS = 05
			MESSAGE = "UNABLE TO RETRACT WINDOW ONE ROW UP"
		CASE KEYPRESS = 24
			MESSAGE = "UNABLE TO EXPAND  WINDOW ONE ROW DOWN"
	ENDCASE
	FRROW  = OLFRRW
	FRCOL  = OLFRCL
	TOROW  = OLTORW
	TOCOL  = OLTOCL
	FRROW1 = OLFRRW1
	FRCOL1 = OLFRCL1
	TOROW1 = OLTORW1
	TOCOL1 = OLTOCL1
ENDCASE
??MSG(MESSAGE)
RETURN
* EOP: -- PROCWERR

*****************
PROCEDURE WINHELP
*****************
DEFINE WINDOW WINHELP FROM 09,09 TO 22,68 DOUBLE
DEFINE WINDOW SDWHELP FROM 10,10 TO 23,69 NONE   COLOR N+/N,N+/N
ACTIVATE WINDOW SDWHELP
ACTIVATE WINDOW WINHELP
@00,01 SAY "Key combinations to define the windows" COLOR GR+/RB
@01,01 SAY "     " + CHR(26) + "    move the right side of the window to the right"
@02,01 SAY "     " + CHR(27) + "    move the right side of the window to the left"
@03,01 SAY "     " + CHR(25) + "    move the bottom side of the window down"
@04,01 SAY "     " + CHR(24) + "    move the bottom side of the window up"
@05,01 SAY "Ctrl " + CHR(26) + "    move the left side of the window to the right"
@06,01 SAY "Ctrl " + CHR(27) + "    move the left side of the window to the left"
@07,01 SAY "Ctrl PgDn move the top side of the window down"
@08,01 SAY "Ctrl PgUp move the top side of the window up"
@09,01 SAY "<Esc>     ends the window definition"
@10,01 SAY "F1        to get this help window"
@11,01 SAY "Press any key to continue" COLOR B*/RB
OLDCURS = SET("CURS")
SET CURS OFF
I = 0
DO WHILE I = 0
	I = INKEY(0)
ENDDO
SET CURS &OLDCURS
DEACTIVATE WINDOW WINHELP, SDWHELP
RELEASE WINDOW WINHELP, SDWHELP
RETURN
* EOP: -- WINHELP
